/// <reference types="node" />
import { EventEmitter } from 'events';
import { GraphQLSchema, GraphQLResolveInfo } from 'graphql';
import { QewlRouterResolver, QewlRouterEvent } from './types';
export declare class Qewl extends EventEmitter {
    schemas: {
        mergedSchema?: GraphQLSchema;
        finalSchema?: GraphQLSchema;
        [name: string]: GraphQLSchema | string;
    };
    resolvers: Array<{
        path: string;
        resolver: QewlRouterResolver | ((event: QewlRouterEvent) => Promise<any> | any);
    }>;
    middlewares: Array<{
        path: string;
        fn: (parent: any, args: {
            [key: string]: any;
        }, context: {
            [key: string]: any;
        }, info: GraphQLResolveInfo, next: any) => any;
    }>;
}
