"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var graphql_1 = require("graphql");
exports.delegate = function (event) { return function (operationType, operationName, args) {
    return event.mergeInfo.delegate(operationType, operationName, args || event.args, event.context, event.info);
}; };
exports.delegateQuery = function (event) { return function (query, vars) {
    return graphql_1.graphql(event.context.qewl.schemas.mergedSchema, query, null, null, vars).then(function (result) {
        return result.data;
    });
}; };
exports.addTypenameField = function (info) {
    var field = {
        kind: 'Field',
        name: { kind: 'Name', value: '__typename' }
    };
    return exports.addFields(info, [field]);
};
exports.addFields = function (info, fields) {
    var newInfo = JSON.parse(JSON.stringify(info));
    if (!(fields instanceof Array)) {
        fields = [fields];
    }
    for (var _i = 0, fields_1 = fields; _i < fields_1.length; _i++) {
        var field = fields_1[_i];
        if (typeof field === 'string') {
            newInfo.fieldNodes[0].selectionSet.selections.push({
                kind: 'Field',
                name: { kind: 'Name', value: field }
            });
        }
        else {
            newInfo.fieldNodes[0].selectionSet.selections.push(field);
        }
    }
    return newInfo;
};
exports.addHelpers = function (event) {
    event.delegate = exports.delegate(event);
    event.delegateQuery = exports.delegateQuery(event);
    event.addFields = function (fields) {
        return (event.info = exports.addFields(event.info, fields));
    };
    event.addTypenameField = function () { return (event.info = exports.addTypenameField(event.info)); };
};
//# sourceMappingURL=helpers.js.map