"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var base_1 = require("./base");
var helpers_1 = require("../helpers");
var lodash_1 = require("lodash");
var graphql_tools_1 = require("graphql-tools");
var graphql_add_middleware_1 = require("graphql-add-middleware");
var memory_cache_1 = require("memory-cache");
function generateSchema() {
    var _this = this;
    return base_1.base(function (req, res, next) { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            generateSchemaImpl(req);
            next();
            return [2 /*return*/];
        });
    }); });
}
exports.generateSchema = generateSchema;
function generateSchemaImpl(req) {
    if (Object.keys(req.qewl.schemas).length === 0) {
        throw new Error('No schemas defined');
    }
    // Only construct schema once
    if (!memory_cache_1.get('qewl.mergedSchema')) {
        // Apply router resolvers
        var resolvers = function (mergeInfo) {
            var resolverBlocks = req.qewl.resolvers.map(function (resolver) {
                return generateResolverBlock(mergeInfo, resolver);
            });
            var resolverObject = {};
            lodash_1.merge.apply(void 0, [resolverObject].concat(resolverBlocks));
            return resolverObject;
        };
        // MergeSchemas
        var schemasToMerge = Object.keys(req.qewl.schemas).map(function (key) { return req.qewl.schemas[key]; });
        req.qewl.schemas.mergedSchema = graphql_tools_1.mergeSchemas({
            schemas: schemasToMerge,
            resolvers: resolvers
        });
        // Apply router middlewares
        for (var _i = 0, _a = req.qewl.middlewares; _i < _a.length; _i++) {
            var middleware = _a[_i];
            graphql_add_middleware_1.addMiddleware(req.qewl.schemas.mergedSchema, middleware.path, middleware.fn);
        }
        memory_cache_1.put('qewl.mergedSchema', req.qewl.schemas.mergedSchema);
    }
    else {
        req.qewl.schemas.mergedSchema = memory_cache_1.get('qewl.mergedSchema');
    }
    req.qewl.emit('schemaGenerated', req.qewl.schemas.mergedSchema);
}
exports.generateSchemaImpl = generateSchemaImpl;
function generateResolverBlock(mergeInfo, resolver) {
    // Create object from path -> apparently, can also use _.set and _.get here :D
    var resolverObject = {};
    var resolveFn;
    if (typeof resolver.resolver === 'function') {
        // This is a 'normal' resolver function
        resolveFn = wrap(resolver.resolver, mergeInfo);
    }
    else {
        resolveFn = __assign({}, resolver.resolver, { resolve: wrap(resolver.resolver.resolve, mergeInfo) });
    }
    lodash_1.set(resolverObject, resolver.path, resolveFn);
    return resolverObject;
}
function wrap(fn, mergeInfo) {
    var _this = this;
    return function (parent, args, context, info) { return __awaiter(_this, void 0, void 0, function () {
        var event;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    event = { parent: parent, args: args, context: context, info: info, mergeInfo: mergeInfo };
                    helpers_1.addHelpers(event);
                    return [4 /*yield*/, fn(event)];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    }); };
}
//# sourceMappingURL=generateSchema.js.map