"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var apollo_link_1 = require("apollo-link");
var node_fetch_1 = require("node-fetch");
var apollo_link_http_1 = require("apollo-link-http");
var graphql_tools_1 = require("graphql-tools");
var base_1 = require("./base");
var lodash_1 = require("lodash");
var util_1 = require("util");
var HttpsProxyAgent = require("https-proxy-agent");
var memory_cache_1 = require("memory-cache");
function remoteSchema(_a) {
    var _this = this;
    var name = _a.name, uri = _a.uri, introspectionSchema = _a.introspectionSchema, link = _a.link, authenticationToken = _a.authenticationToken, _b = _a.forwardHeaders, forwardHeaders = _b === void 0 ? false : _b;
    if (!uri && !link) {
        throw new Error('Specify either uri or link to define remote schema');
    }
    return base_1.base(function (req, res, next) { return __awaiter(_this, void 0, void 0, function () {
        var httpLink, executableSchema;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (link === undefined) {
                        httpLink = apollo_link_http_1.createHttpLink({
                            uri: uri,
                            fetch: node_fetch_1.default,
                            fetchOptions: process.env.HTTPS_PROXY ? { agent: new HttpsProxyAgent(process.env.HTTPS_PROXY) } : {}
                        });
                        if (authenticationToken !== undefined) {
                            link = new apollo_link_1.ApolloLink(function (operation, forward) {
                                operation.setContext(function (ctx) {
                                    var headers = {};
                                    if (ctx && forwardHeaders) {
                                        if (util_1.isBoolean(forwardHeaders)) {
                                            headers = ctx.headers;
                                        }
                                        else {
                                            forwardHeaders.forEach(function (h) { return (headers[h] = ctx.headers[h]); });
                                        }
                                    }
                                    if (ctx && authenticationToken) {
                                        lodash_1.merge(headers, { Authorization: "Bearer " + authenticationToken(ctx) });
                                    }
                                    return { headers: headers };
                                });
                                return forward(operation);
                            }).concat(httpLink);
                        }
                        else {
                            link = httpLink;
                        }
                    }
                    if (name === undefined) {
                        name = "schema" + Object.keys(req.qewl.schemas).length;
                    }
                    if (!(introspectionSchema === undefined)) return [3 /*break*/, 3];
                    if (!!memory_cache_1.get("qewl." + name + ".introspection")) return [3 /*break*/, 2];
                    return [4 /*yield*/, graphql_tools_1.introspectSchema(link)];
                case 1:
                    introspectionSchema = _a.sent();
                    memory_cache_1.put("qewl." + name + ".introspection", introspectionSchema);
                    return [3 /*break*/, 3];
                case 2:
                    introspectionSchema = memory_cache_1.get("qewl." + name + ".introspection");
                    _a.label = 3;
                case 3:
                    executableSchema = graphql_tools_1.makeRemoteExecutableSchema({
                        schema: introspectionSchema,
                        link: link
                    });
                    req.qewl.schemas[name] = executableSchema;
                    next();
                    return [2 /*return*/];
            }
        });
    }); });
}
exports.remoteSchema = remoteSchema;
//# sourceMappingURL=remoteSchema.js.map