"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var graphql_1 = require("graphql");
var base_1 = require("./base");
var graphql_tools_1 = require("graphql-tools");
function schema(def) {
    return base_1.base(function (req, res, next) {
        if (typeof def === 'string' || def instanceof graphql_1.GraphQLSchema) {
            def = { schema: def };
        }
        if (!def.name) {
            def.name = "schema" + Object.keys(req.qewl.schemas).length;
        }
        if (typeof def.schema === 'string') {
            try {
                var actualSchema = graphql_tools_1.makeExecutableSchema({ typeDefs: def.schema });
                def.schema = actualSchema;
            }
            catch (e) { }
        }
        req.qewl.schemas[def.name] = def.schema;
        next();
    });
}
exports.schema = schema;
//# sourceMappingURL=schema.js.map